#-------------------------------------------------------------------------------
# Name:        EAN.pyw
# Purpose:     EAN-Prüfung als Website Beispiel
#
# Author:      Gerhard Röhner
#
# Created:     25.01.2022
# Copyright:   (c) 2022
# Licence:     Freeware
#-------------------------------------------------------------------------------

import tkinter as tk
import tkinter.ttk as ttk

class app(tk.Frame):

    def __init__(self):
        self.root = tk.Tk()
        super().__init__(self.root)
        self.root.geometry('308x195')
        self.root.title('EAN-Prüfung')
        self.create_widgets()
        self.mainloop()

    def create_widgets(self):
        self.lEAN13stellig = tk.Label()
        self.lEAN13stellig.place(x=8, y=24, width=86, height=20)
        self.lEAN13stellig['anchor'] = 'w'
        self.lEAN13stellig['text'] = 'EAN (13-stellig)'
        self.eEAN = tk.Entry()
        self.eEAN.place(x=104, y=24, width=110, height=20)
        self.eEANCV = tk.StringVar()
        self.eEANCV.set('5000112545869')
        self.eEAN['textvariable'] = self.eEANCV
        self.bPruefen = tk.Button()
        self.bPruefen.place(x=224, y=24, width=75, height=25)
        self.bPruefen['command'] = self.bPruefen_Command
        self.bPruefen['text'] = 'Prüfen'
        self.lPruefergebnis = tk.Label()
        self.lPruefergebnis.place(x=8, y=64, width=102, height=20)
        self.lPruefergebnis['anchor'] = 'w'
        self.lPruefergebnis['text'] = 'Prüfergebnis'
        self.Ausgabe = tk.Text()
        self.Ausgabe.place(x=8, y=88, width=288, height=100)
        pass

    def ausgeben(self, Zeile):
        self.Ausgabe.insert('end', Zeile + '\n')

    def bPruefen_Command(self):
        # Eingabe
        EAN = self.eEANCV.get()
        #Verarbeitung
        if not EAN.isdigit():
            self.ausgeben('Eine EAN darf keine anderen Zeichen als Ziffern enthalten!')
        if len(EAN) == 13:
            self.ausgeben('Länge der EAN: 13')
            self.ausgeben('Eingegebene Prüfziffer: ' + EAN[12])
            Summe = 0
            Index = 0
            Faktor = 1
            while Index < 12:
                Summe = Summe + int(EAN[Index])*Faktor
                Index = Index + 1
                if Faktor == 1:
                    Faktor = 3
                else:
                    Faktor = 1
            if Summe % 10 == 0:
                berechnetePrüfziffer = 0
            else:
                berechnetePrüfziffer = 10 - Summe % 10
            if int(EAN[12]) == berechnetePrüfziffer:
                self.ausgeben('Die Prüfziffer ' + EAN[12] + ' ist korrekt!')
            else:
                self.ausgeben('Die eingegebene Prüfziffer ' + EAN[12] + ' ist inkorrekt!')
                self.ausgeben('Die korrekte Prüfziffer ist ' + str(berechnetePrüfziffer))
        else:
            self.ausgeben('Die eingegebene EAN hat ' + str(len(EAN)) + ' Ziffern!')
            self.ausgeben('Sie muss aus 13 Ziffern bestehen.')


app()
